#include "AssetRegistry.h"

#include <iostream>
#include <fstream>
#include <spdlog/spdlog.h>
/*
* this is still a very naive approach to the asset manager
*/

AssetRegistry::AssetRegistry() 
{
}


void AssetRegistry::RegisterAsset(Asset& asset) 
{
	Assets.try_emplace(asset.getId() , asset);
}


void AssetRegistry::UnregisterAsset(Asset& asset) {
	Assets.erase(asset.getId());
}




YoggieEngine::Mesh* AssetRegistry::LoadFromAssetFile(const std::filesystem::path assetPath)
{
	YoggieEngine::Mesh* imported = nullptr;

	std::ifstream AssetFile;
	AssetFile.open(assetPath, std::ios::binary);
	if (AssetFile.is_open()) {

		char* Header = (char*)malloc(8);
		unsigned long long  Vsize = 0;
		uint32_t Vnum = 0;
		uint32_t Enum = 0;

		// Read header 
		AssetFile.read(Header, 8);
		AssetFile.read((char*)&Vsize, sizeof(unsigned long long));
		AssetFile.read((char*)&Vnum, sizeof(uint32_t));
		AssetFile.read((char*)&Enum, sizeof(uint32_t));

		// print Header info 
		spdlog::info("File has header: {0}", Header);
		spdlog::info ( "Vertex size: {0}", Vsize );
		spdlog::info("Number of Vertices: {0}" ,Vnum );
		spdlog::info ("Number of Elements: " , Enum );
		free(Header);


		imported = new YoggieEngine::Mesh();
		// Load Vertices (Vertex + UV )
		imported->vertices = std::vector < YoggieEngine::Vertex>();
		for (int i = 0; i < Vnum; i++)
		{
			YoggieEngine::Vertex data = YoggieEngine::Vertex();
			AssetFile.read((char*)&data, Vsize);

			imported->vertices.push_back(data);

		}

		// skip x bytes 
		AssetFile.ignore(sizeof(char) * 3);

		// Load Elements
		imported->elements = std::vector<unsigned int>();
		for (int i = 0; i < Enum; i++) {
			unsigned int data = 0;
			AssetFile.read((char*)&data, sizeof(unsigned int));
			imported->elements.push_back(data);
		}

	}
	else {
		spdlog::error( "Failed ot open mesh " );
	}

	return imported;


}

YoggieEngine::Renderable* AssetRegistry::LoadFromSource(const std::filesystem::path srcPath, const std::filesystem::path assetFolder)
{

	/*
	* 	auto model = (YoggieEngine::ModelImporter()).Import(srcPath.string());
	YoggieEngine::Mesh* exportMesh = model->renderable->mesh;
	std::filesystem::path MeshFileName = assetFolder / srcPath.filename().replace_extension(".mesh");
	spdlog::info( "Save path: {0}" , MeshFileName );

	std::ofstream meshAsset;
	meshAsset.open(MeshFileName, std::ios::binary);
	if (meshAsset.is_open()) {

		// write a header
		static const char* HEADER = "MESH";
		meshAsset.write(HEADER, sizeof(HEADER));
		auto Vsize = sizeof(YoggieEngine::Vertex);
		spdlog::info( "size of vertex: {0}" ,Vsize );
		spdlog::info("Addr of vSize: {0}" , &Vsize );
		auto Vnum = exportMesh->vertices.size();
		auto Enum = exportMesh->elements.size();

		meshAsset.write((char*)&Vsize, sizeof(unsigned long long));
		meshAsset.write((char*)&Vnum, sizeof(uint32_t));
		meshAsset.write((char*)&Enum, sizeof(uint32_t));
		// write all vertices 
		for (auto& vertice : exportMesh->vertices)
		{
			meshAsset.write((char*)&vertice, sizeof(vertice));
		}

		// write 3 x 0 byte
		meshAsset.write((const char*)"\0\0\0", sizeof(char) * 3);

		// write all indices 
		for (auto index : exportMesh->elements) {
			meshAsset.write((char*)&index, sizeof(index));
		}


		meshAsset.close();
	}
	else {

		spdlog::error("Failed to create/open mesh file.");
	}

	return model->renderable;

	*/
	return nullptr;
}
