#pragma once
#include "../../YoggieEngine/src/YoggieEngine.h"

class EditorCamera : public YoggieEngine::Camera {
public:
	EditorCamera () : Camera(){
		Front = glm::vec3(0.0f, 0.0f, 1.0f);
		Right = glm::vec3(-1.0f, 0.0f, 0.0f);
		Up = glm::vec3(0.0f, 1.0f, 0.0f);

		projection = glm::perspective(glm::radians(65.0f), (800.0f / 600.0f), 0.001f, 100.0f);


		view = glm::translate(glm::mat4(1.0f), Position) * glm::toMat4(glm::quat(Rotation));
	}

	void Update() {

		view = glm::translate(glm::mat4(1.0f), Position) * glm::toMat4(glm::quat(Rotation));
	}

	glm::vec3 Position;
	glm::vec3 Rotation;

private:



	glm::vec3 Front;
	glm::vec3 Right;
	glm::vec3 Up;
};