#pragma once
#include "../../YoggieEngine/src/YoggieEngine.h"
#include "../EditorWindow.h"

#include <glm/glm.hpp>

#include <imgui.h>
#include "../../libs/guizmo/ImGuizmo.h"
#include "../EditorCamera.h"


class Viewport : public EditorWindow {
public:
    bool isFocused = false;
    Viewport(YoggieEngine::Scene& scene, YoggieEngine::Entity& selected);
    Viewport() = default;
    void Draw() override;

    EditorCamera& GetCamera(){ return camera; }

private:
    YoggieEngine::Renderer renderer;
    YoggieEngine::Scene* CurrentScene;
    YoggieEngine::Entity* selected;
    glm::mat4 cameraDelta = glm::mat4(1.0);
    EditorCamera camera;

};