project "YoggieEngine"
  kind "StaticLib"

  pchheader "YoggieEngine.h"
  pchsource "src/YoggieEngine.cpp"


  buildmessage "Building Yoggie Engine"
  disablewarnings{
    "4099" -- Ignore the missing debug signals for GLFW warning
    
  }  

  filter "system:Windows"
    defines{
      "GLFW"
    }

  includedirs {
    "./src",
    "../libs/spdlog/include",
    "../libs/glm",

    "../libs/glfw/include",
    "../libs/glew/include",
    "../libs/glad/include",


    "../libs/assimp/include",
    "../libs/entt/src",

    "../libs/physx/pxshared/include",
    "../libs/physx/physx/include",
    
    "../libs/lua/include",

    "../libs/GorillaAudio/include",
    "../libs/steam-audio/include",

    "../libs/ImGui",
  }

  links {
    -- This needs to fall under the filter as the names can differ on different platforms 
    "phonon",
    "lua54",
    "spdlog",
    "assimp-vc143-mtd",
    "glfw3",
    "ImGui",

    "PhysX_64",
    "PhysXCooking_64",
    "PhysXCommon_64",
    "PhysXFoundation_64",
    "PhysXPvdSDK_static_64",
    "PhysXExtensions_static_64"
    
  }


  libdirs {
    "../libs/steam-audio/lib/windows-x64",
    "../libs/lua",
    "../libs/spdlog/build/Release",
    "../libs/assimp/lib/Debug",
    "../libs/glfw/build/src/Debug",
    "../libs/physx/physx/bin/win.x86_64.vc142.md/debug"
   
  }

  files {

    "src/**.cpp",
    "src/**.h"
  }

  prebuildcommands 
  {
    ok,err = os.copyfile("YoggieEngine/src/Graphics/shaders/*" ,"SandboxApp/build/Debug/")
  }

  postbuildcommands 
  {
    ok,err = os.copyfile("YoggieEngine/build/Debug/intermediates/YoggieEngine.pch", "YoggieEngine/build/Debug/YoggieEngine.pch")
  }

